//res.h

//resilience header file

//immunity, inc.

#include "parser/tracedefs.hpp"

//resilience dimensions can have multiple dimensions inside 
//we use a double here because we need to store both negative numbers
//and UMAX_INT
//They can also have zero dimensions, of course. void *, etc.
struct res_dimension {
     int length;
	 double *value;
};

//structure that stores information about a string for hashing
struct strhash {
	int path;
	int high;
	int percent;
	int ff;
};

void get_str_res(struct res_dimension * res, t_Tracedef_Argument *a);
void strhash_init(struct strhash *myhash);
void strhash_add(struct strhash *myhash, unsigned char newchar) ;
//take the properties we stored off and return a single double for them
double strhash_get(struct strhash *myhash);
void res_add(struct res_dimension * res, double newval);
void res_free(struct res_dimension *res);
void res_print(FILE * fout,struct res_dimension *res);
void res_init(struct res_dimension *res);
void res_add_res(struct res_dimension *res_d,struct res_dimension *res) ;